import processing.video.*;
import processing.serial.*;

Movie myMovie;

// serial port
Serial port;

// Serial variables
String serialString;
String rxString = null; // Anwort vom Ser Port
int cr = 13; // carriage return
int lf = 10; // line feed

int poti;
float duration;

void setup() {

  // print a list of the serial ports, to get the arduino port
  println("Serial ports");
  println(Serial.list());

  // init serial port, on my computer the arduino port is not 
  // neccessarily the first port [0]. Icf your program terminates 
  // with a port error, check for the right number
  port = new Serial(this, Serial.list()[4], 9600);

  size(320, 240);
  //frameRate(25);
  myMovie = new Movie(this, "test.mov");

  // Determines the duration of the Movie
  // (Since this function doesn't work with my Quicktime Version
  // the duration is included manually. But try the following instruction
  // on your computer.
  duration = myMovie.duration();
  println(duration);
  duration = 3.4;

  myMovie.loop();
}

void draw() {

  if (myMovie.available()) {
    myMovie.read();
  }
  image(myMovie, 0, 0);

  //println("v1  "+v1);
  myMovie.jump(map(poti, 0.0, (float)1023, 0.0, duration));
}


// ***************************************************************
// serial event
void serialEvent(Serial p) {

  // get string till line break (ASCII > 13)
  serialString = port.readStringUntil(13);
  // just if there is data
  if (serialString != null) {


    // try catch function because of possible garbage in received data
    try {
      String[] message = splitTokens(serialString);
      // get current value
      poti = Integer.parseInt(message[0]);
    }
    catch (Exception e) {
    }
  }
}



