
#include <SensorAktor.h>
#include <SoftwareServo.h>

#define MOTOR1 1
#define MOTOR2 2
// Buffer-Größe für das Filtern der Gyro-Werte = 10.
#define BUFFERSIZE 20 // Value between 1 - 30

// servo Variablen
SoftwareServo myServo1, myServo2; 
int servo1Position=100;  // Pan Motor
int servo2Position=120;  // Tilt Motor
int servo1StandardPosition=100, servo2StandardPosition=120;

// Gyro Variablen
byte leftByte, rightByte;
char inChar;
float mouseX = 0, mouseY = 0;
int X, L, R, Y;

float meanMouseX[] = {
  0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0,
  0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0,
  0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0};
int mouseXBufferPointer = 0;
float filteredMouseX;
float meanMouseY[] = {
  0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0,
  0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0,
  0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0}; 
int mouseYBufferPointer = 0;
float filteredMouseY;

//Switch1 Variablen
int previous, current = HIGH;
boolean state = false;

void setup()  
{
  Serial.begin(9600);
  Serial.println("Goodnight moon!");

  pinMode(servo1,OUTPUT);
  pinMode(servo1,OUTPUT);
  pinMode(switch1, INPUT_PULLUP);
  pinMode(led3, OUTPUT);

  // verbindet den Servo mit dem Servo-Pin
  myServo1.attach(servo1);
  myServo2.attach(servo2);

  delay(100);
}


void loop() {

  // Einlesen und Verarbeiten Switch1
  previous = current;
  current = digitalRead(switch1);
  if (previous == LOW && current == HIGH) {
    Serial.println("switch1 gedrueckt");
    state = !state;
    digitalWrite(led3, state);
    servo1Position = servo1StandardPosition;
    servo2Position = servo2StandardPosition;
    if (state) {
      for (int i = 0; i < BUFFERSIZE; i++) {
        meanMouseX[i] = 0.0;
        meanMouseY[i] = 0.0;
      }
      filteredMouseX = 0;
      filteredMouseY = 0;
    }
    myServo1.write(servo1Position);
    myServo2.write(servo2Position);
    SoftwareServo::refresh();
    delay(15);
  }

  // Einlesen und Verarbeiten der Mouse-Daten
  if (Serial.available() >= 6) {    
    rightByte = Serial.read();
    leftByte = Serial.read();
    L = (leftByte << 8);
    R = (rightByte << 0);
    X = (L | R);
    mouseX = ((float) (X))/2.0;
    inChar = Serial.read();
    rightByte = Serial.read();
    leftByte = Serial.read();
    L = (leftByte << 8);
    R = (rightByte << 0);
    Y = (L | R);
    mouseY = ((float) (Y))/2.0;
    inChar = Serial.read();

    filteredMouseX = filteredMouseX - meanMouseX[mouseXBufferPointer] + mouseX/BUFFERSIZE;
    meanMouseX[mouseXBufferPointer] = mouseX/BUFFERSIZE;
    mouseXBufferPointer = (mouseXBufferPointer +1)%BUFFERSIZE;

    filteredMouseY = filteredMouseY - meanMouseY[mouseYBufferPointer] + mouseY/BUFFERSIZE;
    meanMouseY[mouseYBufferPointer] = mouseY/BUFFERSIZE;
    mouseYBufferPointer = (mouseYBufferPointer +1)%BUFFERSIZE;

    Serial.print(mouseX);
    Serial.print("  ");
    Serial.print(mouseY);
    Serial.println();
  }

  // Nur wenn led1 leuchtet werden die servo-Daten ausgewertet.
  if (state) {
    /*Serial.print("Gefilterete Gyro-Werte mouseX und mouseY:  ");
     Serial.print(filteredMouseX);
     Serial.print("  ");
     Serial.print(filteredMouseY);
     Serial.print("  Servo Positions  ");
     Serial.print(servo1Position);
     Serial.print("  ");
     Serial.println(servo2Position);*/

    // + oder - in den naechsten beiden Operaionen bestimmt, wie der Gyro zu halten ist.
    servo1Position = servo1StandardPosition + (int) mouseX;
    servo2Position = servo2StandardPosition - (int) mouseY;

    // Die servo-Daten werden innerhalb der Servo-Grenzen gesetzt [1 - 179] Grad
    // Servo1 = Pan Motor und Servo2 = Tilt Motor
    if (servo1Position < 5)
      servo1Position = 5;
    if (servo1Position  > 175)
      servo1Position = 175;
    if (servo2Position < 60)
      servo2Position = 60;
    if (servo2Position  > 160)
      servo2Position = 160;

    myServo1.write(servo1Position);
    myServo2.write(servo2Position);
    SoftwareServo::refresh();

    delay(10);
  }
}



































