
import processing.serial.*;

Serial port;  // The serial port object

int oldMouseX, oldMouseY;
short mouseXDiff, mouseYDiff;
int X, Y;
int startX = 0, startY = 0;
byte leftByte, rightByte;

void setup() {
  size(255, 255);
  background(255, 255, 255);

  println(Serial.list());
  port = new Serial(this, Serial.list()[5], 9600);

  stroke(0);
  // Request values right off the bat
  //port.write(65);
}

void draw() {

  if (mouseXDiff != 0 || mouseYDiff != 0) {
    // write message to arduino
    // read least significant byte
    rightByte = byte(mouseXDiff & 0xff);
    // read most significant byte
    leftByte = byte((mouseXDiff >> 8) & 0xff);
    // write both bytes
    port.write(rightByte);
    port.write(leftByte);
    port.write('\t');
    // do the same for the second integer
    rightByte = byte(mouseYDiff & 0xff);
    leftByte = byte((mouseYDiff >> 8) & 0xff);
    port.write(rightByte);
    port.write(leftByte);    
    port.write('\n');
  }
  delay(50);
}

void serialEvent(Serial port) {
  String input = port.readString();
  print(input);
}

void mouseReleased() {
  background(255, 255, 255);
  oldMouseX = mouseX = startX = 0;
  oldMouseY = mouseY = startY = 0;
}

void mousePressed() {
  background(255, 255, 255);
  oldMouseX = mouseX;
  oldMouseY = mouseY;
  mouseXDiff = 0;
  mouseYDiff = 0;
  startX = X = mouseX;
  startY = Y = mouseY;
}

void mouseDragged() {
  X = mouseX;
  Y = mouseY;
  line(oldMouseX, oldMouseY, X, Y);
  oldMouseX = X;
  oldMouseY = Y;

  mouseXDiff = (short) (X - startX);
  mouseYDiff = (short) (Y - startY);
  //println("MouseXDiff  "+mouseXDiff+" MouseYDiff "+mouseYDiff);
}

